<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:jsf="http://xmlns.jcp.org/jsf">
 	 <head jsf:id="head">
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
 		<title>Welcome to JSF 2.3 Chat!</title>
 		<h:outputStylesheet library="css" name="bootstrap.min.css" />
 		<script>
 			function handleOpen(event) {
 	 			console.log('Openning ', event);
 			}
 			
 			function handleChatChannelMessage(message, event) {
 				const textarea = document.getElementById('chat-history');
				textarea.append(message);
				textarea.append('\n');
                textarea.scrollTop = textarea.scrollHeight;
	 		}
	 		
	 		function handleClockChannelMessage(message, event) {
		 		alert('Time is: ' + message)
		 	}
		 	
 			function handleMessage(message, channelName, event) {
 	 			if (channelName === 'chatChannel') {
 	 				handleChatChannelMessage(message, event);
 	 			} else if (channelName === 'clock') {
 	 	 			handleClockChannelMessage(message, event);
	 	 		} else {
		 	 		alert('Unhandled channel: ' + channelName);
		 	 	}
			}
			
			function handleClose(code, channel, event) {
				console.log('Handle close: ' + code, channel, event);
				if (code == -1) {
					console.log('Websockets not supported by client')
				} else if (code == 1000) { // Normal close (as result of expired session or view)
					console.log('Normal close, will try to reconnect');
				} else {
					// Abnormal close reason (as result of an error)
					alert('Error during the reconnect!')
				}
			}
 		</script>
 	</head>
    <body jsf:id="body">
		<!-- The JSF Socket is only one-way: from Server to Client (Spec 10.4.1.7).
			We will need to do an AJAX call to broadcast a message;
			Must be at body -->
		<f:websocket scope="application" channel="chatChannel" onopen="handleOpen" onmessage="handleMessage" onclose="handleClose" />
		 
		<f:websocket scope="application" channel="clock" onopen="handleOpen" onmessage="handleMessage" onclose="handleClose" />
		
	    <div class="container">
	    	<div class="jumbotron">
				<h1>Welcome to JSF 2.3 Chat</h1>
			</div>
			<form class="form-vertical" jsf:id="form" jsf:prependId="false">
				<div class="row">
					<div class="col-sm-12 center-block"><h2>bienvenido #{BeanInicio.nickSecion()}</h2></div>
				</div>
				<div class="row">
					<div class="col-sm-12">
						<textarea id="chat-history" class="form-control" rows="10" cols="70" readonly="true" style="resize:none;"></textarea>
					</div>
				</div>
				<div class="row">
					<div class="col-sm-12">
						<div class="input-group">
							<input type="text" class="form-control" placeholder="Enter your message"
								jsf:id="message" jsf:name="message" jsf:value="#{chatController.message}" />
							<span class="input-group-btn">
								<button type="button" class="btn btn-primary" jsf:id="btn-send">Send
									<f:ajax event="click" execute="@this message" render="@this message chat-history" listener="#{chatController.sendMessage()}" />
								</button>
								<button type="button" class="btn btn-primary" jsf:id="btn-update">Clock
									<f:ajax event="click" execute="@this" render="@this" listener="#{chatController.updateClock()}" />
								</button>
					    	</span>
						</div>
					</div>
				</div>
				
				<div class="row">
					<div class="col-sm-12">
						<h:messages globalOnly="true" errorClass="alert alert-danger" warnClass="alert alert-warning" infoClass="alert alert-success"
							style="padding-left:0px;list-style:none;" />
					</div>
				</div>
			</form>
		</div>
    </body>
</html>
